Index: resources/views/dashboard/folders/files.blade.php
===================================================================
--- resources/views/dashboard/folders/files.blade.php	(revision 0208bbd325187250445476f15e12ab189830c9db)
+++ resources/views/dashboard/folders/files.blade.php	(revision 9012e8143e20146ffefd559770f887d89e496a50)
@@ -9,7 +9,9 @@
             <div class="card">
                 <div class="card-body">
+                    @if(auth()->user()->hasPermission('manage_all_folders'))
                     <a class="btn btn-secondary btn-block text-white" href="javascript:void(0)" data-target="#editModal_{{$folder->id}}" data-toggle="modal">
                         Upload
                     </a>
+                        @endif
                 </div>
                 <div class="app-sidebar-menu">
@@ -35,4 +37,5 @@
                 <div class="action-left">
                     <ul class="list-inline">
+                        @if(auth()->user()->hasPermission('manage_all_folders'))
                         <li class="list-inline-item mb-0">
                             <a href="#" class="btn btn-outline-light dropdown-toggle" data-toggle="dropdown">
@@ -43,11 +46,13 @@
                                     Upload
                                 </a>
-
                             </div>
                         </li>
+                        @endif
                         <li class="list-inline-item mb-0">
+                            @if(auth()->user()->hasPermission('download_data'))
                             <a href="{{ route("dashboard.folders.downloadFolder", ['id' => $folder->id]) }}" class="btn btn-outline-light">
                                 Download folder
                             </a>
+                                @endif
                         </li>
                     </ul>
@@ -100,13 +105,19 @@
                                     </a>
                                     <div class="dropdown-menu dropdown-menu-right">
+                                        @if(auth()->user()->hasPermission('manage_all_files'))
                                         <a href="javascript:void(0)" class="dropdown-item" data-toggle="modal" data-target="#editFileModal_{{$file->id}}">
                                             Rename
                                         </a>
+                                        @endif
+                                        @if(auth()->user()->hasPermission('download_data'))
                                         <a href="{{ route("dashboard.files.downloadFile", $file->id) }}" class="dropdown-item">
                                             Download
                                         </a>
+                                            @endif
+                                            @if(auth()->user()->hasPermission('manage_all_files'))
                                         <a href="javascript:void(0)" class="dropdown-item" data-toggle="modal" data-target="#deleteModal_{{$file->id}}">
                                             Delete
                                         </a>
+                                                @endif
                                     </div>
                                 </div>
Index: resources/views/dashboard/folders/index.blade.php
===================================================================
--- resources/views/dashboard/folders/index.blade.php	(revision 0208bbd325187250445476f15e12ab189830c9db)
+++ resources/views/dashboard/folders/index.blade.php	(revision 9012e8143e20146ffefd559770f887d89e496a50)
@@ -9,7 +9,9 @@
             <div class="card">
                 <div class="card-body">
+                    @if(auth()->user()->hasPermission('manage_all_folders'))
                     <a href="javascript:void(0)" class="btn btn-secondary btn-block file-upload-btn text-white" data-toggle="modal" data-target="#createModal">
                         Add folder
                     </a>
+                        @endif
                 </div>
                 <div class="app-sidebar-menu">
@@ -62,14 +64,18 @@
                 <div class="action-left">
                     <ul class="list-inline">
+                        @if(auth()->user()->hasPermission('manage_all_folders'))
                         <li class="list-inline-item mb-0">
                             <a href="#" class="btn btn-outline-light dropdown-toggle" data-toggle="dropdown">
                                 <i data-feather="plus" class="mr-1"></i>
-                                Ations
+                                Actions
                             </a>
                             <div class="dropdown-menu">
                                 <a class="dropdown-item" href="javascript:void(0)" data-toggle="modal" data-target="#createModal">Add folder</a>
+                                @endif
+                                    @if(auth()->user()->hasPermission('export_data'))
                                 <a href="{{ route('dashboard.folders.export') }}" class="dropdown-item text-success">Export</a>
                             </div>
                         </li>
+                        @endif
                         <li class="list-inline-item mb-0">
                             <a href="#" class="btn btn-outline-light dropdown-toggle" data-toggle="dropdown">Departments</a>
@@ -139,7 +145,12 @@
                                         <div class="dropdown-menu dropdown-menu-right">
                                             <a href="{{ route("dashboard.folders.files", ["id" => $folder->id]) }}" class="dropdown-item">View Files</a>
+                                            @if(auth()->user()->hasPermission('manage_all_folders'))
                                             <a href="javascript:void(0)" class="dropdown-item" data-toggle="modal" data-target="#editModal_{{$folder->id}}">Edit</a>
+                                            @endif
+                                            @if(auth()->user()->hasPermission('download_data'))
                                             <a href="{{ route("dashboard.folders.downloadFolder", ['id' => $folder->id]) }}" class="dropdown-item">Download</a>
-                                            <button class="dropdown-item action-dropdown-item"
+                                            @endif
+                                            @if(auth()->user()->hasPermission('manage_all_folders'))
+                                                <button class="dropdown-item action-dropdown-item"
                                                     href="javascript:void(0)" onclick="toggleImportant({{$folder->id}})">
                                                 @if($folder->is_important)
@@ -149,5 +160,8 @@
                                                 @endif
                                             </button>
+                                            @endif
+                                            @if(auth()->user()->hasPermission('manage_all_folders'))
                                             <a href="javascript:void(0)" class="dropdown-item" data-toggle="modal" data-target="#deleteModal_{{$folder->id}}">Delete</a>
+                                            @endif
                                         </div>
                                     </div>