Index: src/main/java/edu/gjoko/schedlr/config/AppSecurityConfig.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/config/AppSecurityConfig.java	(revision 1413ee288bce0d328676a027fdef65e0f7ad576d)
+++ src/main/java/edu/gjoko/schedlr/config/AppSecurityConfig.java	(revision 53765ddd7eb6bc0f9ce45bc734229dd648e2557e)
@@ -68,5 +68,5 @@
                 .antMatchers("/register_customer").permitAll()
                 .antMatchers("/register_business").permitAll()
-                .antMatchers("/api/nomenclatures/*").permitAll()
+                .antMatchers("/api/nomenclature/*").permitAll()
                 .antMatchers("/api/user/me").permitAll()
                 .antMatchers("/api/business").permitAll()
Index: src/main/java/edu/gjoko/schedlr/controllers/LoginController.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/controllers/LoginController.java	(revision 1413ee288bce0d328676a027fdef65e0f7ad576d)
+++ src/main/java/edu/gjoko/schedlr/controllers/LoginController.java	(revision 53765ddd7eb6bc0f9ce45bc734229dd648e2557e)
@@ -22,5 +22,5 @@
     @PostMapping(path = "/login")
     public String loginCustomer(@ModelAttribute Stakeholder customer, Model model) {
-        return "redirect:homepage";
+        return "redirect:login";
     }
 }
Index: src/main/java/edu/gjoko/schedlr/controllers/rest/NomenclatureApi.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/controllers/rest/NomenclatureApi.java	(revision 1413ee288bce0d328676a027fdef65e0f7ad576d)
+++ src/main/java/edu/gjoko/schedlr/controllers/rest/NomenclatureApi.java	(revision 53765ddd7eb6bc0f9ce45bc734229dd648e2557e)
@@ -2,14 +2,17 @@
 
 import edu.gjoko.schedlr.entity.BusinessType;
+import edu.gjoko.schedlr.entity.ServiceType;
 import edu.gjoko.schedlr.services.NomenclaturesService;
 import lombok.AllArgsConstructor;
 import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.PathVariable;
 import org.springframework.web.bind.annotation.RequestMapping;
 import org.springframework.web.bind.annotation.RestController;
 
+import javax.servlet.http.HttpServletRequest;
 import java.util.List;
 
 @RestController
-@RequestMapping("api/nomenclatures")
+@RequestMapping("api/nomenclature")
 @AllArgsConstructor
 public class NomenclatureApi {
@@ -20,3 +23,9 @@
         return nomenclaturesService.getBusinessTypes();
     }
+
+    @GetMapping( "/serviceTypes/me")
+    public List<ServiceType> getServiceTypesForBusinessType( HttpServletRequest request) {
+        Long ownerId = (long) request.getSession(true).getAttribute("stakeholderId");
+        return nomenclaturesService.findAppropriateBusinessTypesForBusinessByOwnerId(ownerId);
+    }
 }
Index: src/main/java/edu/gjoko/schedlr/entity/Service.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/entity/Service.java	(revision 1413ee288bce0d328676a027fdef65e0f7ad576d)
+++ src/main/java/edu/gjoko/schedlr/entity/Service.java	(revision 53765ddd7eb6bc0f9ce45bc734229dd648e2557e)
@@ -56,5 +56,5 @@
     @Column(name = "service_status")
     @Enumerated(EnumType.STRING)
-    private ServiceStatus serviceStatus;
+    private ServiceStatus serviceStatus = ServiceStatus.ACTIVE;
 
     @Column(name = "created")
Index: src/main/java/edu/gjoko/schedlr/repositories/ServiceTypeRepository.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/repositories/ServiceTypeRepository.java	(revision 1413ee288bce0d328676a027fdef65e0f7ad576d)
+++ src/main/java/edu/gjoko/schedlr/repositories/ServiceTypeRepository.java	(revision 53765ddd7eb6bc0f9ce45bc734229dd648e2557e)
@@ -1,12 +1,19 @@
 package edu.gjoko.schedlr.repositories;
 
-import edu.gjoko.schedlr.entity.BusinessType;
+import edu.gjoko.schedlr.entity.Service;
 import edu.gjoko.schedlr.entity.ServiceType;
 import org.springframework.data.jpa.repository.JpaRepository;
-import org.springframework.data.jpa.repository.Modifying;
 import org.springframework.data.jpa.repository.Query;
 import org.springframework.stereotype.Repository;
 
+import java.util.List;
+
 @Repository
 public interface ServiceTypeRepository extends JpaRepository<ServiceType, Long> {
+
+    List<ServiceType> findAllByBusinessType_Id(Long businessTypeId);
+
+    @Query(value = "select b.businessType.serviceTypes from Business as b " +
+            " where b.owner.id = :ownerId")
+    List<ServiceType> findAppropriateBusinessTypesForBusinessByOwnerId(Long ownerId);
 }
Index: src/main/java/edu/gjoko/schedlr/services/NomenclaturesService.java
===================================================================
--- src/main/java/edu/gjoko/schedlr/services/NomenclaturesService.java	(revision 1413ee288bce0d328676a027fdef65e0f7ad576d)
+++ src/main/java/edu/gjoko/schedlr/services/NomenclaturesService.java	(revision 53765ddd7eb6bc0f9ce45bc734229dd648e2557e)
@@ -2,4 +2,5 @@
 
 import edu.gjoko.schedlr.entity.BusinessType;
+import edu.gjoko.schedlr.entity.ServiceType;
 import edu.gjoko.schedlr.repositories.BusinessTypeRepository;
 import edu.gjoko.schedlr.repositories.ServiceTypeRepository;
@@ -20,3 +21,7 @@
         return businessTypeRepository.findAll();
     }
+
+    public List<ServiceType> findAppropriateBusinessTypesForBusinessByOwnerId(Long ownerId) {
+        return serviceTypeRepository.findAppropriateBusinessTypesForBusinessByOwnerId(ownerId);
+    }
 }